"use strict";
var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : new P(function (resolve) { resolve(result.value); }).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
var __generator = (this && this.__generator) || function (thisArg, body) {
    var _ = { label: 0, sent: function() { if (t[0] & 1) throw t[1]; return t[1]; }, trys: [], ops: [] }, f, y, t, g;
    return g = { next: verb(0), "throw": verb(1), "return": verb(2) }, typeof Symbol === "function" && (g[Symbol.iterator] = function() { return this; }), g;
    function verb(n) { return function (v) { return step([n, v]); }; }
    function step(op) {
        if (f) throw new TypeError("Generator is already executing.");
        while (_) try {
            if (f = 1, y && (t = op[0] & 2 ? y["return"] : op[0] ? y["throw"] || ((t = y["return"]) && t.call(y), 0) : y.next) && !(t = t.call(y, op[1])).done) return t;
            if (y = 0, t) op = [op[0] & 2, t.value];
            switch (op[0]) {
                case 0: case 1: t = op; break;
                case 4: _.label++; return { value: op[1], done: false };
                case 5: _.label++; y = op[1]; op = [0]; continue;
                case 7: op = _.ops.pop(); _.trys.pop(); continue;
                default:
                    if (!(t = _.trys, t = t.length > 0 && t[t.length - 1]) && (op[0] === 6 || op[0] === 2)) { _ = 0; continue; }
                    if (op[0] === 3 && (!t || (op[1] > t[0] && op[1] < t[3]))) { _.label = op[1]; break; }
                    if (op[0] === 6 && _.label < t[1]) { _.label = t[1]; t = op; break; }
                    if (t && _.label < t[2]) { _.label = t[2]; _.ops.push(op); break; }
                    if (t[2]) _.ops.pop();
                    _.trys.pop(); continue;
            }
            op = body.call(thisArg, _);
        } catch (e) { op = [6, e]; y = 0; } finally { f = t = 0; }
        if (op[0] & 5) throw op[1]; return { value: op[0] ? op[1] : void 0, done: true };
    }
};
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
var fs_1 = __importDefault(require("fs"));
var path_1 = __importDefault(require("path"));
var util_1 = __importDefault(require("util"));
var readline_1 = __importDefault(require("readline"));
var lodash_1 = __importDefault(require("lodash"));
var i18next_1 = __importDefault(require("i18next"));
var i18next_node_fs_backend_1 = __importDefault(require("i18next-node-fs-backend"));
var stream_buffers_1 = require("stream-buffers");
var source_map_1 = require("source-map");
var VirtualModulePlugin = require('virtual-module-webpack-plugin');
var readFile = util_1.default.promisify(fs_1.default.readFile);
var unlink = util_1.default.promisify(fs_1.default.unlink);
var stat = util_1.default.promisify(fs_1.default.stat);
var mkdir = util_1.default.promisify(fs_1.default.mkdir);
function exists(path) {
    return __awaiter(this, void 0, void 0, function () {
        var e_1;
        return __generator(this, function (_a) {
            switch (_a.label) {
                case 0:
                    _a.trys.push([0, 2, , 3]);
                    return [4 /*yield*/, stat(path)];
                case 1:
                    _a.sent();
                    return [2 /*return*/, true];
                case 2:
                    e_1 = _a.sent();
                    if (e_1.code === 'ENOENT') {
                        return [2 /*return*/, false];
                    }
                    throw e_1;
                case 3: return [2 /*return*/];
            }
        });
    });
}
function extractArgs(arg, warning) {
    switch (arg.type) {
        case 'Literal':
            return { type: "literal", value: {
                    key: arg.value,
                    line: arg.loc.start.line,
                    column: arg.loc.start.column
                } };
        case 'Identifier':
            return { type: "identifier", name: arg.name };
        case 'ObjectExpression':
            return { type: "empty" };
        case 'ConditionalExpression':
            return {
                type: "and",
                value: [
                    extractArgs(arg.consequent, warning),
                    extractArgs(arg.alternate, warning)
                ]
            };
        case 'ArrayExpression':
            return {
                type: "or",
                value: lodash_1.default.map(arg.elements, function (element) { return extractArgs(element, warning); })
            };
        case 'BinaryExpression':
            var operator = arg.operator;
            var left = extractArgs(arg.left, warning);
            var right = extractArgs(arg.right, warning);
            if (operator !== "+" || left.type !== "literal" || right.type !== "literal") {
                if (warning) {
                    warning(arg);
                }
                return { type: "empty" };
            }
            return {
                type: "literal",
                value: {
                    key: left.value.key + right.value.key,
                    line: left.value.line,
                    column: left.value.column
                }
            };
        default:
            if (warning) {
                warning(arg);
            }
            return { type: "empty" };
    }
}
var DummySourceMapConsumer = /** @class */ (function () {
    function DummySourceMapConsumer(module) {
        this.file = module.resource;
        this.sourceRoot = module.resource;
        this.sources = [this.file];
        this.sourcesContent = [module._source._value];
    }
    DummySourceMapConsumer.prototype.computeColumnSpans = function () { };
    DummySourceMapConsumer.prototype.originalPositionFor = function (generatedPosition) {
        return lodash_1.default.assign({
            source: this.file,
            name: ""
        }, generatedPosition);
    };
    DummySourceMapConsumer.prototype.generatedPositionFor = function (originalPosition) {
        return lodash_1.default.assign({
            lastColumn: originalPosition.column
        }, originalPosition);
    };
    DummySourceMapConsumer.prototype.allGeneratedPositionsFor = function (originalPosition) {
        return [this.generatedPositionFor(originalPosition)];
    };
    DummySourceMapConsumer.prototype.hasContentsOfAllSources = function () { return true; };
    DummySourceMapConsumer.prototype.sourceContentFor = function (source, returnNullOnMissing) {
        var index = this.sources.indexOf(source);
        if (index === -1) {
            if (returnNullOnMissing) {
                return "";
            }
            else {
                throw new Error("never");
            }
        }
        return this.sourcesContent[index];
    };
    DummySourceMapConsumer.prototype.eachMapping = function () { };
    DummySourceMapConsumer.prototype.destroy = function () { };
    return DummySourceMapConsumer;
}());
function getPath(template, language, namespace) {
    if (language !== undefined) {
        template = template.replace("{{lng}}", language);
    }
    if (namespace !== undefined) {
        template = template.replace("{{ns}}", namespace);
    }
    return template;
}
function removeMap(obj, keys) {
    for (var _i = 0, keys_1 = keys; _i < keys_1.length; _i++) {
        var emptyKey = keys_1[_i];
        if (emptyKey !== undefined) {
            delete obj[emptyKey];
        }
    }
    return obj;
}
var I18nextPlugin = /** @class */ (function () {
    function I18nextPlugin(option) {
        this.missingKeys = {};
        this.startTime = Date.now();
        this.prevTimestamps = {};
        this.sourceMaps = {};
        this.missingDirInitialized = false;
        this.option = lodash_1.default.defaults(option, {
            functionName: "__",
            defaultNamespace: "translation",
            namespaceSeparator: ":",
            namespaces: [option.defaultNamespace || "translation"],
            outPath: option.resourcePath
        });
        i18next_1.default.use(i18next_node_fs_backend_1.default);
    }
    I18nextPlugin.prototype.apply = function (compiler) {
        var _this = this;
        // provide config via virtual module plugin
        compiler.apply(new VirtualModulePlugin({
            moduleName: path_1.default.join(__dirname, "config.js"),
            contents: "exports = module.exports = {\n    __esModule: true,\n    RESOURCE_PATH: \"" + this.option.outPath + "\",\n    LANGUAGES: " + JSON.stringify(this.option.languages) + ",\n    DEFAULT_NAMESPACE: \"" + this.option.defaultNamespace + "\",\n    NS_SEPARATOR: \"" + this.option.namespaceSeparator + "\",\n};"
        }));
        i18next_1.default.init({
            preload: this.option.languages,
            ns: this.option.namespaces,
            fallbackLng: false,
            defaultNS: this.option.defaultNamespace,
            saveMissing: true,
            parseMissingKeyHandler: this.onKeyMissing.bind(this),
            backend: {
                loadPath: this.option.resourcePath
            }
        });
        this.context = compiler.options.context || "";
        this.initMissingDir();
        compiler.plugin("compilation", function (compilation, data) {
            // reset for new compliation
            i18next_1.default.reloadResources(_this.option.languages);
            _this.compilation = compilation;
            var changedFiles = lodash_1.default.keys(compilation.fileTimestamps).filter(function (watchfile) { return (_this.prevTimestamps[watchfile] || _this.startTime) < (compilation.fileTimestamps[watchfile] || Infinity); });
            for (var _i = 0, changedFiles_1 = changedFiles; _i < changedFiles_1.length; _i++) {
                var changed = changedFiles_1[_i];
                delete _this.sourceMaps[changed];
            }
            removeMap(_this.missingKeys, lodash_1.default.map(_this.missingKeys, function (namespaces, lng) {
                return lodash_1.default.isEmpty(removeMap(namespaces, lodash_1.default.map(namespaces, function (values, ns) {
                    return lodash_1.default.isEmpty(removeMap(values, lodash_1.default.map(values, function (deps, key) {
                        for (var _i = 0, changedFiles_2 = changedFiles; _i < changedFiles_2.length; _i++) {
                            var changed = changedFiles_2[_i];
                            delete deps[changed];
                        }
                        return lodash_1.default.isEmpty(deps) ? key : undefined;
                    }))) ? ns : undefined;
                }))) ? lng : undefined;
            }));
            data.normalModuleFactory.plugin("parser", function (parser) {
                var that = _this;
                parser.plugin("call " + _this.option.functionName, function (arg) {
                    return I18nextPlugin.onTranslateFunctionCall.call(this, that, arg);
                });
            });
        });
        compiler.plugin("emit", this.onEmit.bind(this));
        compiler.plugin("after-emit", this.onAfterEmit.bind(this));
    };
    I18nextPlugin.prototype.initMissingDir = function () {
        return __awaiter(this, void 0, void 0, function () {
            var template;
            var _this = this;
            return __generator(this, function (_a) {
                switch (_a.label) {
                    case 0:
                        if (this.missingDirInitialized) {
                            return [2 /*return*/];
                        }
                        template = path_1.default.resolve(this.context, this.option.pathToSaveMissing);
                        return [4 /*yield*/, Promise.all(this.option.namespaces.map(function (ns) { return _this.option.languages.map(function (lng) { return __awaiter(_this, void 0, void 0, function () {
                                var dirPath;
                                return __generator(this, function (_a) {
                                    switch (_a.label) {
                                        case 0:
                                            dirPath = path_1.default.dirname(getPath(template, lng, ns));
                                            return [4 /*yield*/, exists(dirPath)];
                                        case 1:
                                            if (!!(_a.sent())) return [3 /*break*/, 3];
                                            return [4 /*yield*/, mkdir(dirPath)];
                                        case 2:
                                            _a.sent();
                                            _a.label = 3;
                                        case 3: return [2 /*return*/];
                                    }
                                });
                            }); }); }))];
                    case 1:
                        _a.sent();
                        this.missingDirInitialized = true;
                        return [2 /*return*/];
                }
            });
        });
    };
    I18nextPlugin.prototype.onEmit = function (compilation, callback) {
        return __awaiter(this, void 0, void 0, function () {
            var e_2;
            var _this = this;
            return __generator(this, function (_a) {
                switch (_a.label) {
                    case 0:
                        // emit translation files
                        this.prevTimestamps = compilation.fileTimestamps;
                        _a.label = 1;
                    case 1:
                        _a.trys.push([1, 3, , 4]);
                        return [4 /*yield*/, Promise.all(lodash_1.default.flatten(lodash_1.default.map(this.option.languages, function (lng) { return __awaiter(_this, void 0, void 0, function () {
                                var resourceTemplate, resourceDir;
                                var _this = this;
                                return __generator(this, function (_a) {
                                    switch (_a.label) {
                                        case 0:
                                            resourceTemplate = path_1.default.resolve(this.context, getPath(this.option.resourcePath, lng));
                                            resourceDir = path_1.default.dirname(resourceTemplate);
                                            return [4 /*yield*/, exists(resourceDir)];
                                        case 1:
                                            if (!(_a.sent())) {
                                                compilation.missingDependencies.push(resourceDir);
                                                return [2 /*return*/, []];
                                            }
                                            return [2 /*return*/, Promise.all(lodash_1.default.map(this.option.namespaces, function (ns) { return __awaiter(_this, void 0, void 0, function () {
                                                    var resourcePath, outPath, v_1, e_3;
                                                    return __generator(this, function (_a) {
                                                        switch (_a.label) {
                                                            case 0:
                                                                resourcePath = getPath(resourceTemplate, undefined, ns);
                                                                outPath = getPath(this.outPath, lng, ns);
                                                                _a.label = 1;
                                                            case 1:
                                                                _a.trys.push([1, 3, , 4]);
                                                                return [4 /*yield*/, readFile(resourcePath)];
                                                            case 2:
                                                                v_1 = _a.sent();
                                                                compilation.assets[outPath] = {
                                                                    size: function () { return v_1.length; },
                                                                    source: function () { return v_1; }
                                                                };
                                                                compilation.fileDependencies.push(path_1.default.resolve(resourcePath));
                                                                return [3 /*break*/, 4];
                                                            case 3:
                                                                e_3 = _a.sent();
                                                                compilation.missingDependencies.push(resourcePath);
                                                                compilation.warnings.push("Can't emit " + outPath + ". It looks like " + resourcePath + " is not exists.");
                                                                return [3 /*break*/, 4];
                                                            case 4: return [2 /*return*/];
                                                        }
                                                    });
                                                }); }))];
                                    }
                                });
                            }); })))];
                    case 2:
                        _a.sent();
                        callback();
                        return [3 /*break*/, 4];
                    case 3:
                        e_2 = _a.sent();
                        callback(e_2);
                        return [3 /*break*/, 4];
                    case 4: return [2 /*return*/];
                }
            });
        });
    };
    Object.defineProperty(I18nextPlugin.prototype, "outPath", {
        get: function () {
            if (path_1.default.isAbsolute(this.option.outPath)) {
                return path_1.default.relative(this.context, this.option.outPath);
            }
            return this.option.outPath;
        },
        enumerable: true,
        configurable: true
    });
    I18nextPlugin.prototype.onAfterEmit = function (compilation, callback) {
        return __awaiter(this, void 0, void 0, function () {
            var remains, e_4;
            var _this = this;
            return __generator(this, function (_a) {
                switch (_a.label) {
                    case 0:
                        remains = lodash_1.default.fromPairs(lodash_1.default.map(this.option.languages, function (lng) { return [
                            lng,
                            lodash_1.default.fromPairs(lodash_1.default.map(_this.option.namespaces, function (ns) { return [ns, null]; }))
                        ]; }));
                        _a.label = 1;
                    case 1:
                        _a.trys.push([1, 5, , 6]);
                        // write missing
                        return [4 /*yield*/, this.initMissingDir()];
                    case 2:
                        // write missing
                        _a.sent();
                        return [4 /*yield*/, Promise.all(lodash_1.default.map(this.missingKeys, function (namespaces, lng) { return __awaiter(_this, void 0, void 0, function () {
                                var resourceTemplate, resourceDir, e_5;
                                var _this = this;
                                return __generator(this, function (_a) {
                                    switch (_a.label) {
                                        case 0:
                                            resourceTemplate = path_1.default.resolve(this.context, getPath(this.option.pathToSaveMissing, lng));
                                            resourceDir = path_1.default.dirname(resourceTemplate);
                                            _a.label = 1;
                                        case 1:
                                            _a.trys.push([1, 3, , 4]);
                                            return [4 /*yield*/, mkdir(resourceDir)];
                                        case 2:
                                            _a.sent();
                                            return [3 /*break*/, 4];
                                        case 3:
                                            e_5 = _a.sent();
                                            if (e_5.code !== 'EEXIST') {
                                                throw e_5;
                                            }
                                            return [3 /*break*/, 4];
                                        case 4: return [4 /*yield*/, Promise.all(lodash_1.default.map(namespaces, function (values, ns) { return new Promise(function (resolve) {
                                                delete remains[lng][ns];
                                                var missingPath = getPath(resourceTemplate, undefined, ns);
                                                var stream = fs_1.default.createWriteStream(missingPath, {
                                                    encoding: "utf-8"
                                                });
                                                var keys = lodash_1.default.sortedUniq(lodash_1.default.sortBy(lodash_1.default.keys(values)));
                                                stream.write("{\n");
                                                stream.write(lodash_1.default.map(keys, function (key) { return "\t\"" + key + "\": [\n" + lodash_1.default.map(values[key], function (pos, module) { return "\t\t\"" + lodash_1.default.trim(JSON.stringify(path_1.default.relative(_this.context, module)), '"') + "(" + pos + ")\""; }).join(",\n") + "\n\t]"; }).join(",\n"));
                                                stream.end("\n}");
                                                stream.on("close", function () { return resolve(); });
                                                compilation.warnings.push("missing translation " + lodash_1.default.size(values) + " keys in " + lng + "/" + ns);
                                            }); }))];
                                        case 5: return [2 /*return*/, _a.sent()];
                                    }
                                });
                            }); }))];
                    case 3:
                        _a.sent();
                        // remove previous missings
                        return [4 /*yield*/, Promise.all(lodash_1.default.map(remains, function (namespaces, lng) {
                                return Promise.all(lodash_1.default.map(namespaces, function (__, ns) { return __awaiter(_this, void 0, void 0, function () {
                                    var missingPath;
                                    return __generator(this, function (_a) {
                                        switch (_a.label) {
                                            case 0:
                                                missingPath = path_1.default.resolve(this.context, getPath(this.option.pathToSaveMissing, lng, ns));
                                                return [4 /*yield*/, exists(missingPath)];
                                            case 1:
                                                if (!_a.sent()) return [3 /*break*/, 3];
                                                return [4 /*yield*/, unlink(missingPath)];
                                            case 2:
                                                _a.sent();
                                                _a.label = 3;
                                            case 3: return [2 /*return*/];
                                        }
                                    });
                                }); }));
                            }))];
                    case 4:
                        // remove previous missings
                        _a.sent();
                        callback();
                        return [3 /*break*/, 6];
                    case 5:
                        e_4 = _a.sent();
                        callback(e_4);
                        return [3 /*break*/, 6];
                    case 6: return [2 /*return*/];
                }
            });
        });
    };
    I18nextPlugin.prototype.argsToSource = function (sourceMap, arg) {
        var beginPos = sourceMap.originalPositionFor(arg.loc.start);
        var endPos = sourceMap.originalPositionFor(arg.loc.end);
        if (beginPos.source !== null) {
            var originalSource = sourceMap.sourceContentFor(beginPos.source);
            var sourceLines_1 = [];
            if (originalSource !== null) {
                var buffer_1 = new stream_buffers_1.ReadableStreamBuffer();
                buffer_1.put(originalSource);
                buffer_1.put("\n");
                var lineIdx_1 = 0;
                return new Promise(function (resolve) {
                    var lineInterface = readline_1.default.createInterface(buffer_1).on("line", function (line) {
                        lineIdx_1++;
                        var beginCol = 0, endCol = line.length;
                        if (lineIdx_1 === beginPos.line) {
                            beginCol = beginPos.column;
                        }
                        if (lineIdx_1 === endPos.line) {
                            endCol = endPos.column;
                        }
                        if (lineIdx_1 >= beginPos.line && lineIdx_1 <= endPos.line) {
                            sourceLines_1.push(line.substring(beginCol, endCol));
                        }
                        if (lineIdx_1 === endPos.line) {
                            lineInterface.close();
                        }
                    }).on("close", function () {
                        resolve(sourceLines_1.join("\n"));
                    });
                });
            }
        }
        return Promise.resolve(null);
    };
    I18nextPlugin.onTranslateFunctionCall = function (plugin, expr) {
        return __awaiter(this, void 0, void 0, function () {
            var resource, _a, _b, sourceMap, arg, _i, _c, lng, _d, _e, failed, _f, ns, k, startPos;
            return __generator(this, function (_g) {
                switch (_g.label) {
                    case 0:
                        resource = this.state.current.resource;
                        if (!(plugin.sourceMaps[resource] === undefined && this.state.current._source._sourceMap !== undefined)) return [3 /*break*/, 2];
                        _a = plugin.sourceMaps;
                        _b = resource;
                        return [4 /*yield*/, new source_map_1.SourceMapConsumer(this.state.current._source._sourceMap)];
                    case 1:
                        _a[_b] = _g.sent();
                        return [3 /*break*/, 3];
                    case 2:
                        plugin.sourceMaps[resource] = new DummySourceMapConsumer(this.state.current);
                        _g.label = 3;
                    case 3:
                        sourceMap = plugin.sourceMaps[resource];
                        arg = extractArgs(expr.arguments[0], function (arg) { return plugin.argsToSource(sourceMap, arg).then(function (originalSource) {
                            var beginPos = sourceMap.originalPositionFor(arg.loc.start);
                            if (originalSource !== null) {
                                plugin.warningOnCompilation("unable to parse arg " + originalSource + " at " + resource + ":(" + beginPos.line + ", " + beginPos.column + ")");
                            }
                            else {
                                plugin.warningOnCompilation("unable to parse node at " + resource + ":(" + beginPos.line + ", " + beginPos.column + ")");
                            }
                        }); });
                        for (_i = 0, _c = plugin.option.languages; _i < _c.length; _i++) {
                            lng = _c[_i];
                            for (_d = 0, _e = plugin.testArg(arg, lng); _d < _e.length; _d++) {
                                failed = _e[_d];
                                _f = plugin.separateNamespace(failed.key), ns = _f[0], k = _f[1];
                                startPos = sourceMap !== undefined ? sourceMap.originalPositionFor(failed) : failed;
                                plugin.addToMissingKey(lng, ns, k, [resource, startPos.line, startPos.column]);
                            }
                        }
                        return [2 /*return*/];
                }
            });
        });
    };
    I18nextPlugin.prototype.separateNamespace = function (key) {
        var ret = key.split(this.option.namespaceSeparator, 2);
        if (ret.length === 1) {
            ret.unshift(this.option.defaultNamespace);
        }
        return ret;
    };
    I18nextPlugin.prototype.testArg = function (arg, lng) {
        var faileds = [];
        switch (arg.type) {
            case "empty":
                break;
            case "and":
                for (var _i = 0, _a = arg.value; _i < _a.length; _i++) {
                    var key = _a[_i];
                    faileds.push.apply(faileds, this.testArg(key, lng));
                }
                break;
            case "or":
                for (var _b = 0, _c = arg.value; _b < _c.length; _b++) {
                    var key = _c[_b];
                    var result = this.testArg(key, lng);
                    if (result.length === 0) {
                        return [];
                    }
                    else {
                        faileds.push.apply(faileds, result);
                    }
                }
                break;
            case "literal":
                if (!i18next_1.default.t(arg.value.key, { lng: lng })) {
                    faileds.push(arg.value);
                }
                break;
        }
        return faileds;
    };
    I18nextPlugin.prototype.addToMissingKey = function (lng, ns, key, pos) {
        var p = [lng, ns, key, pos[0]];
        var arr = lodash_1.default.get(this.missingKeys, p);
        if (arr === undefined) {
            lodash_1.default.set(this.missingKeys, p, []);
            arr = lodash_1.default.get(this.missingKeys, p);
        }
        arr.push([pos[1], pos[2]]);
    };
    I18nextPlugin.prototype.onKeyMissing = function () {
        return false;
    };
    I18nextPlugin.prototype.warningOnCompilation = function (msg) {
        if (this.compilation) {
            this.compilation.warnings.push(msg);
        }
    };
    return I18nextPlugin;
}());
exports.default = I18nextPlugin;
//# sourceMappingURL=index.js.map